<?php

function getsubdirectories($path)
{
 $path = rtrim($path, '/'); // ensure no trailing slash, so we can insert one in $full
 $sets = false;
 if($handle = opendir($path))
 {
  // Loop through all files
  while(false !== ($file = readdir($handle)))
  {  
   // Ignore hidden files
   if(!preg_match("/^\./", $file))
   {    
    // Put dirs in $dirs[] and files in $files[]
    $full = $path.'/'.$file;
    if (is_dir($full) && $file != '')
    {
     $sets[] = $file;
    }
   }
  }
 }
 closedir($handle);
 return $sets;
}

function getfiles($path, $extension = false)
{ // collect all files from directory
 global $debug;
 $sets = false;
  if($handle = @opendir($path))
  {
   // Loop through all files
   while(false !== ($file = readdir($handle)))
   {  
    // Ignore hidden files
    if(!preg_match("/^\./", $file))
    {    
     // Put files in $files[]
     $full = $path.'/'.$file;
     if (!is_dir($full) && $file != '')
     {
	if (!$extension || $extension == extension($file)) $sets[] = $file; 
     }
    }
   }
  }
  @closedir($handle);
 return $sets;
} 

function removedirectory($directory, $empty = false, $leaveitself = false)
{ // recursively empties and removes specified directory
 // if the path has a slash at the end we remove it here
 if(substr($directory,-1) == '/') $directory = substr($directory,0,-1);
 // if the path is not valid or is not a directory ...
 if (!file_exists($directory) || !is_dir($directory)) return false;
 else if (!is_readable($directory)) return false;
 else
 {
  $handle = opendir($directory);
  while (FALSE !== ($item = readdir($handle)))
  {
	if($item != '.' && $item != '..')
	{
		$path = $directory.'/'.$item;
		if(is_dir($path)) removedirectory($path);
		else	
		{
		 unlink($path);
		} 
	}
  }
  closedir($handle);
  if ($empty == false && !$leaveitself) { rmdir($directory); }
  return true;
 }
}

function makedirectory($file, $mod = false)
{
 $test = mkdir($file, 0755, true); // do recursively
 return $test;	
}


function limitedtemplateextract($template, $stringbegin, $stringend)
{
 // Don't leave beginning string in
 if (strstr($template, $stringbegin) && strstr($template, $stringend))
 {
  $start = strpos($template, $stringbegin) + strlen($stringbegin); // get beginning position
  $restoftemplate = substr($template, $start);
  $stop = strpos($restoftemplate, $stringend) + $start; // get end position
  $length = $stop - $start; // calculate length
  $subtemplate = substr($template, $start, $length); // carve out what we want
  return $subtemplate;
 }
 else return false;
}

?>